/** Rill v0.0.499 https://www.npmjs.com/package/rill License: MIT*/
var Request, expect, parseURL;

parseURL = require("./util/parseURL");

expect = require("./util/expect");

Request = (function() {
  function Request(req, basePath) {
    var key, ref, ref1, ref2, ref3, ref4, val;
    if (basePath == null) {
      basePath = "";
    }
    if (!(this instanceof Request)) {
      return new Request(req, basePath);
    }
    expect(req != null, "Could not create Request with an empty object.");
    this.req = req;
    this.url = req.url;
    this.headers = (ref = req.headers) != null ? ref : {};
    this.method = (ref1 = req.method) != null ? ref1 : "GET";
    {
      this.ip = (ref2 = (ref3 = this.headers['x-forwarded-for']) != null ? ref3.split(',')[0] : void 0) != null ? ref2 : req.connection.remoteAddress;
      this.protocol = req.socket.encrypted ? "https:" : "http:";
    }
    ref4 = parseURL(this, basePath);
    for (key in ref4) {
      val = ref4[key];
      this[key] = val;
    }
  }


  /*
  	 * Trigger another request that will redirect the browser and send a location change on the server.
  	 * If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
  	#
  	 * @param {String} url
  	 * @param {String} alt
   */

  Request.prototype.redirect = function(url, alt) {
    if (url == null) {
      url = "back";
    }
    if (alt == null) {
      alt = "/";
    }
    if (url === "back") {
      url = (this.headers["Referrer"]) || alt;
    }
    return this.redirectURL = url;
  };

  return Request;

})();

module.exports = Request;
