parseURL = require("./util/parseURL")
expect   = require("./util/expect")

class Request
	constructor: (req, basePath = "")->
		return new Request(req, basePath) unless this instanceof Request
		expect(req?, "Could not create Request with an empty object.")

		@req = req
		@url         = req.url
		@headers     = req.headers ? {}
		@method      = req.method ? "GET"

		if process.browser
			@ip = "127.0.0.1"
		else
			@ip = @headers['x-forwarded-for']?.split(',')[0] ? req.connection.remoteAddress
			@protocol = if req.socket.encrypted then "https:" else "http:"

		@[key] = val for key, val of parseURL(@, basePath)

	###
	# Trigger another request that will redirect the browser and send a location change on the server.
	# If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
	#
	# @param {String} url
	# @param {String} alt
	###
	redirect: (url="back", alt="/")->
		if url is "back"
			url = (
				if process.browser then document.referrer
				else @headers["Referrer"]
			) or alt
		@redirectURL = url

module.exports = Request
