urllite    = require("urllite")
parseDates = require("./util/parseDates")
expect     = require("./util/expect")
httpReg    = /^https?:\/\//i
dateReg    = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*))(?:Z|(\+|-)([\d|:]*))?$/

parsers = module.exports =
	###
	# When used as a transform for JSON.parse date strings will be turned into date objects.
	#
	# @param {String} key
	# @param {String} val
	###
	date: (key, val)->
		if "string" is typeof val and dateReg.test(val) then new Date(val)
		else val

	###
	# Extract a parsed url from a request object.
	#
	# @param {Request} req
	###
	url: (req, basePath)->
		expect(req.url, "Could not parse an empty url.")
		location = if process.browser then window.location else req

		url = urllite(
			if httpReg.test(req.url) then req.url
			else location.protocol + "//" + location.host + req.url
		)

		result =
			protocol:    url.protocol[0...-1]
			host:        url.host
			hostname:    url.hostname
			port:        url.port
			path:        url.pathname.replace(basePath, "")
			querystring: url.search[1...]
			hash:        url.hash[1...]
			origin:      url.origin
			subdomains:  url.host.split('.').reverse().slice(2)
			query:       try JSON.parse(result.querystring, parsers.date)
